﻿'********************************************************************************
'*								                                        		*						                                        		*
'*      非線形方程式の解　VB2005サンプル1    2013年(平成25年) 10月              *
'*							                                        			*						                                        			*			
'********************************************************************************
Imports System.Math
Module Module1
    Public Declare Function Brent_VB1 Lib "CALC11.dll" (ByVal MJ As String, ByVal XL As Double, ByVal XH As Double, _
           ByVal Y As Double, ByVal Z As Double, ByRef PNUM As Integer) As Integer

    Public Declare Function Brent_VB2 Lib "CALC11.dll" (ByVal i As Short) As Double

    Dim MOJ = "x*(x^2-25)"                           ' MOJ=非線形方程式
    Dim XL = -10, XH = 10, Y = 0, Z = 0, ANSW As Double  ' XLOW#=答えの下限値  XHIG#=答えの上限値  
                                                         ' Y,Z : 変数   ANSW=答え
    Dim RCODE, PNUM As Integer				 ' RCODE=終了コード   PNUM=解の数

    Dim ans, Fans As String : Dim i As Short

    Sub Main()
        RCODE = Brent_VB1(MOJ, XL, XH, Y, Z, PNUM)  ' DLL Call(MOJ,XL,XH,Y,ZをDLLに渡し、解の数(=PNUM)を受け取る)
        If RCODE > 99 Then Exit Sub ' 致命的エラー
        Console.WriteLine("方程式     ＝ " & MOJ)
        Console.WriteLine("終了コード ＝ " & RCODE)
        Console.WriteLine("解の数     ＝ " & PNUM)
        Console.WriteLine("解") : Console.WriteLine(Chr(13))   ' 改行

        '---------結果の表示 (解)-----------------------------------------------------------
        For i = 0 To PNUM - 1
            ANSW = Brent_VB2(i)                     ' DLL Call( 解(=ANSW)を受け取る )
            ans = "" : ans = "0.#####"
            If Abs(ANSW) >= 10.0 Then ans = "#0.####"
            If Abs(ANSW) >= 100.0 Then ans = "##0.###"
            If Abs(ANSW) >= 1000.0 Then ans = "###0.##"
            If Abs(ANSW) >= 1000.0 Then ans = "####0.#"
            If Abs(ANSW) >= 10000.0 Then ans = "######"
            Fans = Format(ANSW, ans)
            If ANSW >= 0 Then Fans = Space(1) + Fans
            Console.WriteLine("   " & Fans)
        Next
        MsgBox("正常に終了しました。", 64, "終了メッセージ")
    End Sub
End Module
